use juno_compiler::*;

use clap::Parser;

use std::path::PathBuf;

#[derive(Parser)]
#[clap(author, version, about, long_about = None)]
struct Cli {
    src_file: String,
    #[clap(short, long, value_name = "SCHEDULE")]
    schedule: Option<String>,
    #[arg(short, long = "output-dir", value_name = "OUTPUT DIR")]
    output_dir: Option<String>,
}

fn main() {
    let args = Cli::parse();
    let output_dir = match args.output_dir {
        Some(dir) => dir,
        None => PathBuf::from(args.src_file.clone())
            .parent()
            .unwrap()
            .to_str()
            .unwrap()
            .to_string(),
    };
    match compile(args.src_file, args.schedule, output_dir) {
        Ok(()) => {}
        Err(errs) => {
            eprintln!("{}", errs);
        }
    }
}
