#![feature(box_as_ptr, let_chains)]

use hercules_rt::HerculesBox;

juno_build::juno!("nested_ccp");

fn main() {
    async_std::task::block_on(async {
        let mut a: Box<[f32]> = Box::new([17.0, 18.0, 19.0]);
        let mut b: Box<[i32]> = Box::new([12, 16, 4, 18, 23, 56, 93, 22, 14]);
        let a = HerculesBox::from_slice_mut(&mut a);
        let b = HerculesBox::from_slice_mut(&mut b);
        let output_example = ccp_example(a).await;
        let output_median = median_array(9, b).await;
        let out_no_underflow = no_underflow().await;
        println!("{}", output_example);
        println!("{}", output_median);
        println!("{}", out_no_underflow);
        assert_eq!(output_example, 1.0);
        assert_eq!(output_median, 18);
        assert_eq!(out_no_underflow, 7);
    });
}

#[test]
fn nested_ccp_test() {
    main();
}
